#!/usr/bin/env python
from __future__ import division
from rtlsdr import *
from pylab import *
from time import time
import sys


#directory = '/home/superkuh/www/gnuradio/live'

# this script creates spectrograms and log files, all put into the above directory.
# The spectrograms are named by frequency. The logs come in both per frequency and
# an "all.log" format.

def main():
# while true; do perl radioscan_faster.pl -d2 /tmp/faster -f1 40 -f2 1700 -fast -g 30 -r 2400000 -s 1.2 -c 751 -m -p; sleep 1; done;
# python graphfreqs_faster.py 40000000 2400000 30 -58 /tmp/faster 1700000000
# yeah, I should use getopts or something...
	myfreq2 = 40000000
        myfreq = int(sys.argv[1])
	mysrate = int(sys.argv[2])
	mygain = int(sys.argv[3])
	myoffset = 0 # default
	myoffset = int(sys.argv[4])
	directory = '/home/superkuh/www/gnuradio/live'
	directory = sys.argv[5]
	myfreq2 = 1700000000
        myfreq2 = int(sys.argv[6])
#	print 'debug: ' + str(myfreq) + ',' + str(mysrate) + ',' + str(mygain) + ',' + str(myoffset)
	myspacing = 1200000
	myspacing = int(sys.argv[7])


        sdr = RtlSdr()
        sdr.rs = mysrate
	sdr.err_ppm = myoffset
        sdr.gain = mygain

	for i in range(myfreq, myfreq2, myspacing):
	        sdr.fc = i
		intendedfreq = i
	        print '  sample rate: %0.6f MHz' % (sdr.rs/1e6)
	        print 'Center frequency %0.6f MHz' % (sdr.fc/1e6)
	        print '  gain: %d dB' % sdr.gain
		print '  ppm correction: %d ppm' % sdr.err_ppm
		samples = sdr.read_samples(256*1024)
		
		if intendedfreq == int(sdr.fc):
			
#			print 'Good frequency match.'
	
			logfile = directory + '/' + str(int(sdr.fc)) + '.log'
			f = open(logfile, 'a+')
			f.write( str(time()) + ' , ' + '%0.2f' % (10*log10(var(samples))) + ' , ' + str(sdr.gain) + ' , ' + str(sdr.err_ppm) + '\n')

			logfile2 = directory + '/' + 'all.log'
			f = open(logfile2, 'a+')
			f.write( str(time()) + ' ' + str(int(sdr.fc)) + ' ' + '%0.2f' % (10*log10(var(samples))) + ' ' + str(sdr.gain) + ' ' + str(sdr.err_ppm) + '\n')
		else:
			print 'Bad frequency match for some reason. Skipping logs.'
			errorlog = '/home/superkuh/error.log'
			f = open(errorlog, 'a+')
			f.write( str(time()) + ' ' + str(int(sdr.fc)) +  ' ' + intendedfreq + '\n')



       	print 'Done\n'
        sdr.close()

# really? um, I guess this was for the async callback stuff which I don't understand.
if __name__ == '__main__':
    main()

#@limit_calls(2)
#def test_callback(samples, rtlsdr_obj):
#    print '  in callback'
#    print '  signal mean:', sum(samples)/len(samples)
#        print 'Testing callback...'
#        sdr.read_samples_async(test_callback, 256*1024)

